# This file allows other CMake Projects to find us
# We provide general project information
# and reestablish the exported CMake Targets

# Multiple inclusion guard
if(NOT nda_FOUND)
set(nda_FOUND TRUE)
set_property(GLOBAL PROPERTY nda_FOUND TRUE)

# version
set(nda_VERSION 1.2.0 CACHE STRING "nda version")
set(nda_GIT_HASH 147479e2fe1dd23790273f16cf736e75a98ef5c0 CACHE STRING "nda git hash")

# Root of the installation
set(nda_ROOT /Users/runner/miniforge3/conda-bld/triqs_1696152366641/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla CACHE STRING "nda root directory")

# Find OpenMP
find_package(OpenMP REQUIRED COMPONENTS CXX)

# Find CUDAToolkit
if(OFF)
  find_package(CUDAToolkit REQUIRED)
endif()

## Find the target dependencies
function(find_dep)
  get_property(${ARGV0}_FOUND GLOBAL PROPERTY ${ARGV0}_FOUND)
  if(NOT ${ARGV0}_FOUND)
    find_package(${ARGN} REQUIRED HINTS /Users/runner/miniforge3/conda-bld/triqs_1696152366641/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla)
  endif()
endfunction()
find_dep(itertools 1.2)
find_dep(mpi 1.2)
find_dep(h5 1.2)
if(ON)
  find_dep(Cpp2Py 2.0)
endif()

# Include the exported targets of this project
include(/Users/runner/miniforge3/conda-bld/triqs_1696152366641/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib/cmake/nda/nda-targets.cmake)

message(STATUS "Found nda-config.cmake with version 1.2.0, hash = 147479e2fe1dd23790273f16cf736e75a98ef5c0, root = /Users/runner/miniforge3/conda-bld/triqs_1696152366641/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla")

# Was the Project built with Documentation?
set(nda_WITH_DOCUMENTATION OFF CACHE BOOL "Was nda build with documentation?")

# Was the Project built with PythonSupport?
set(nda_WITH_PYTHON_SUPPORT ON CACHE BOOL "Was nda build with python support?")
if(ON)
  set(nda_MODULE_DIR /Users/runner/miniforge3/conda-bld/triqs_1696152366641/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_pla/lib/python3.8/site-packages CACHE BOOL "The nda python module directory")
endif()

# Was the Project built with CudaSupport?
set(nda_WITH_CUDA_SUPPORT OFF CACHE BOOL "Was nda build with Cuda support?")

endif()
